UVA1493 - Draw a Mess(并查集)
UVA1493 - Draw a Mess(并查集)
题目大意:一个N * M 的矩阵,每次你在上面将某个范围上色,不论上面有什么颜色都会被最新的颜色覆盖,颜色是1-9,初始的颜色是0.最后输出这个矩形中。每一个颜色有多少个。某个范围这个分为了四种,圆,矩形,菱形,还有正三角形(倒着的)。注意这题的边界,不能超出这个矩形,非常easy越界。
解题思路:由于题的矩阵范围是200 * 50000,然后操作又是50000,这样三个相乘,即使给60s也是不够的。由于行的数目比較少。假设每次都能将这一行哪个没处理过直接拿出来。而不用一个一个推断就快非常多了,这样一来就相当于每一个格子仅仅要遍历一次。所以这里就每行用一个并查集。标记这这个位置以及后面的位置能够上色的起始位置。
然后颜色更新问题仅仅要将操作反着过来上色就能够处理了。
代码:
#include <cstdio>
#include <cstring>
#include <cmath>
#include <cstdlib>
#include <algorithm>
using namespace std;
const int M = 50005;
const int N = 205;
int f[N][M];
int G[N][M];
int color[10];
int n, m, q;
char str[N];
struct OP {
char type;
int x, y, l, r, c;
}op[M];
int getParent (int x, int y) {
return y == f[x][y] ?
y : f[x][y] = getParent (x, f[x][y]);
}
void init() {
for (int i = q - 1; i >= 0; i--) {
scanf ("%s", str);
if (str[0] == 'D')
scanf ("%d%d%d%d", &op[i].x, &op[i].y, &op[i].l, &op[i].c);
else if (str[0] == 'T')
scanf ("%d%d%d%d", &op[i].x, &op[i].y, &op[i].l, &op[i].c);
else if (str[0] == 'R')
scanf ("%d%d%d%d%d", &op[i].x, &op[i].y, &op[i].l, &op[i].r, &op[i].c);
else
scanf ("%d%d%d%d", &op[i].x, &op[i].y, &op[i].l, &op[i].c);
op[i].type = str[0];
}
for (int i = 0; i <= n; i++)
for (int j = 0; j <= m; j++)
f[i][j] = j;
memset (color, 0, sizeof (color));
}
void circle (int x, int y, int r, int c) {
int L, R, s;
for (int i = -r; i <= r; i++) {
s = sqrt(r * r - i * i);
if (i + x >= n || i + x < 0)
continue;
L = max(y - s, 0);
L = max (getParent (i + x, L), L);
R = min (s + y, m - 1);
for (int j = L; j <= R; j++) {
if (j == getParent (i + x, j)) {
color[c]++;
f[i + x][j] = R + 1;
} else
j = getParent(i + x, j) - 1;
}
}
}
void diamond (int x, int y, int r, int c) {
int L, R;
for (int i = -r; i <= r; i++) {
if (i + x >= n || i + x < 0)
continue;
R = min (r - abs(i) + y, m - 1);
L = max (abs(i) - r + y, 0);
L = max (L, getParent (i + x, L));
for (int j = L; j <= R; j++) {
if (j == getParent (i + x, j)) {
color[c]++;
f[i + x][j] = R + 1;
} else
j = getParent (i + x, j) - 1;
}
}
}
void rectangle (int x, int y, int l, int w, int c) {
int L, R;
for (int i = x; i < min(x + l, n); i++) {
L = max (y, getParent (i, y));
R = min (y + w - 1, m - 1);
for (int j = L; j <= R; j++) {
if (j == getParent (i, j)) {
color[c]++;
f[i][j] = R + 1;
} else
j = getParent (i, j) - 1;
}
}
}
void triangle (int x, int y, int w, int c) {
int L, R, h;
h = (w + 1) / 2;
for (int i = 0; i < h; i++) {
if (i + x >= n)
break;
L = max (y - h + i + 1, 0);
L = max (getParent(i + x, L), L);
R = min (y + h - i - 1, m - 1);
for (int j = L; j <= R; j++) {
if (j == getParent (i + x, j)) {
color[c]++;
f[i + x][j] = R + 1;
} else
j = getParent (i + x, j) - 1;
}
}
}
void solve () {
for (int i = 0; i < q; i++) {
if (op[i].type == 'D')
diamond (op[i].x, op[i].y, op[i].l, op[i].c);
else if (op[i].type == 'C')
circle (op[i].x , op[i].y, op[i].l, op[i].c);
else if (op[i].type == 'T')
triangle (op[i].x, op[i].y, op[i].l, op[i].c);
else
rectangle (op[i].x, op[i].y, op[i].l, op[i].r, op[i].c);
}
}
int main () {
char str[N];
while (scanf ("%d%d%d", &n, &m, &q) != EOF) {
init ();
solve();
for (int i = 1; i < 9; i++)
printf ("%d ", color[i]);
printf ("%d\n", color[9]);
}
return 0;
}
UVA1493 - Draw a Mess(并查集)的更多相关文章
- uva 1493 - Draw a Mess(并查集)
题目链接:uva 1493 - Draw a Mess 题目大意:给定一个矩形范围,有四种上色方式,后面上色回将前面的颜色覆盖,最后问9种颜色各占多少的区域. 解题思路:用并查集维护每一个位置相应下一 ...
- Draw a Mess (并查集)
It's graduated season, every students should leave something on the wall, so....they draw a lot of g ...
- UVA 1493 Draw a Mess(并查集+set)
这题我一直觉得使用了set这个大杀器就可以很快的过了,但是网上居然有更好的解法,orz... 题意:给你一个最大200行50000列的墙,初始化上面没有颜色,接着在上面可能涂四种类型的形状(填充): ...
- 并查集(涂色问题) HDOJ 4056 Draw a Mess
题目传送门 题意:给出一个200 * 50000的像素点矩阵,执行50000次操作,每次把一个矩形/圆形/菱形/三角形内的像素点涂成指定颜色,问最后每种颜色的数量. 分析:乍一看,很像用线段树成段更新 ...
- 【HDOJ】4056 Draw a Mess
这题用线段树就MLE.思路是逆向思维,然后每染色一段就利用并查集将该段移除,均摊复杂度为O(n*m). /* 4056 */ #include <iostream> #include &l ...
- POJ 2912 - Rochambeau - [暴力枚举+带权并查集]
题目链接:http://poj.org/problem?id=2912 Time Limit: 5000MS Memory Limit: 65536K Description N children a ...
- CodeForces Roads not only in Berland(并查集)
H - Roads not only in Berland Time Limit:2000MS Memory Limit:262144KB 64bit IO Format:%I64d ...
- POJ2912 Rochambeau [扩展域并查集]
题目传送门 Rochambeau Time Limit: 5000MS Memory Limit: 65536K Total Submissions: 4463 Accepted: 1545 ...
- POJ2912:Rochambeau(带权并查集)
Rochambeau Time Limit: 5000MS Memory Limit: 65536K Total Submissions: 5208 Accepted: 1778 题目链接:h ...
随机推荐
- Builder设计模式--改善构造器多个参数时可显著改善可读性
作为一名程序开发者,设计模式其实一直有在接触,只是没有专门的去学过,所以可能对设计模式没有一个系统的理解.在一次项目中,需要使用到第三方服务商提供的功能,为了尽快的熟悉其功能代码,在官网下了demo来 ...
- NVIDIA DIGITS 学习笔记(NVIDIA DIGITS-2.0 + Ubuntu 14.04 + CUDA 7.0 + cuDNN 7.0 + Caffe 0.13.0)
转自:http://blog.csdn.net/enjoyyl/article/details/47397505?from=timeline&isappinstalled=0#10006-we ...
- 小技巧:tar命令打包目录时,排除文件和目录的命令
今天不巧要用上,百度. tar zcvf fd.tar.gz pardir --exclude=pardir/file1 --exclude=pardir/dir1
- JavaScript(获取或设置html元素的宽,高,坐标),确定和判断鼠标是否在元素内部,二级导航菜单鼠标离开样式问题解决
设置: document.getElementById('id').style.width=value document.getElementById('id').style.height=va ...
- EOJ 3256 拼音魔法
模拟. 有$a$先标$a$,其次是$o$和$e$,$o$和$e$在韵母中不会同时存在.最后是$u$和$i$,这两个字母在韵母中可能同时存在,标在后面的那个.输出那些字符的话直接输出就可以了. 举几个例 ...
- 洛谷P2296 寻找道路 [拓扑排序,最短路]
题目传送门 寻找道路 题目描述 在有向图G 中,每条边的长度均为1 ,现给定起点和终点,请你在图中找一条从起点到终点的路径,该路径满足以下条件: 1 .路径上的所有点的出边所指向的点都直接或间接与终点 ...
- Android中xml tool属性
http://www.jcodecraeer.com/a/anzhuokaifa/androidkaifa/2015/0309/2567.html 我是搬运工.. 总结而言tool属性就是为了在IDE ...
- ajax个人总结
ajax是什么? AJAX = Asynchronous JavaScript and XML(异步的 JavaScript 和 XML). AJAX 不是新的编程语言,而是一种使用现有标准的新方法. ...
- 关于maven工程的几个BUG
换了个新的环境,重新导入的maven工程出现了2个BUG: 1.Could not calculate build plan: Plugin org.apache.maven.plugins:mave ...
- Prime Number CodeForces - 359C (属于是数论)
Simon has a prime number x and an array of non-negative integers a1, a2, ..., an. Simon loves fracti ...